*** ../nagios-orig/xdata/xodtemplate.c	Wed Mar 24 23:28:31 2004
--- xdata/xodtemplate.c	Thu Mar 25 13:20:55 2004
***************
*** 3662,3677 ****
  	        }
  
  
! 	/****** DUPLICATE SERVICE ESCALATION DEFINITIONS WITH MULTIPLE DESCRIPTIONS ******/
  	/* THIS MUST BE DONE AFTER DUPLICATING FOR MULTIPLE HOST NAMES (SEE ABOVE) */
  	for(temp_serviceescalation=xodtemplate_serviceescalation_list;temp_serviceescalation!=NULL;temp_serviceescalation=temp_serviceescalation->next){
  
  		/* skip serviceescalations without enough data */
! 		if(temp_serviceescalation->service_description==NULL || temp_serviceescalation->host_name==NULL)
  			continue;
  
  		/* get list of services */
! 		temp_servicelist=xodtemplate_expand_servicegroups_and_services(NULL,temp_serviceescalation->host_name,temp_serviceescalation->service_description);
  		if(temp_servicelist==NULL){
  #ifdef NSCORE
  			snprintf(temp_buffer,sizeof(temp_buffer)-1,"Error: Could not expand services specified in service escalation (config file '%s', starting on line %d)\n",xodtemplate_config_file_name(temp_serviceescalation->_config_file),temp_serviceescalation->_start_line);
--- 3662,3677 ----
  	        }
  
  
! 	/****** DUPLICATE SERVICE ESCALATION DEFINITIONS WITH MULTIPLE DESCRIPTIONS AND/OR SERVICEGROUPS ******/
  	/* THIS MUST BE DONE AFTER DUPLICATING FOR MULTIPLE HOST NAMES (SEE ABOVE) */
  	for(temp_serviceescalation=xodtemplate_serviceescalation_list;temp_serviceescalation!=NULL;temp_serviceescalation=temp_serviceescalation->next){
  
  		/* skip serviceescalations without enough data */
! 		if((temp_serviceescalation->service_description==NULL || temp_serviceescalation->host_name==NULL) && temp_serviceescalation->servicegroup_name==NULL)
  			continue;
  
  		/* get list of services */
! 		temp_servicelist=xodtemplate_expand_servicegroups_and_services(temp_serviceescalation->servicegroup_name,temp_serviceescalation->host_name,temp_serviceescalation->service_description);
  		if(temp_servicelist==NULL){
  #ifdef NSCORE
  			snprintf(temp_buffer,sizeof(temp_buffer)-1,"Error: Could not expand services specified in service escalation (config file '%s', starting on line %d)\n",xodtemplate_config_file_name(temp_serviceescalation->_config_file),temp_serviceescalation->_start_line);
***************
*** 3688,3746 ****
  			/* if this is the first duplication, use the existing entry */
  			if(first_item==TRUE){
  
- 				free(temp_serviceescalation->service_description);
- 				temp_serviceescalation->service_description=strdup(this_servicelist->service_description);
- 				if(temp_serviceescalation->service_description==NULL){
- 					xodtemplate_free_servicelist(temp_servicelist);
- 					return ERROR;
- 				        }
- 
- 				first_item=FALSE;
- 				continue;
- 			        }
- 
- 			/* duplicate service escalation definition */
- 			result=xodtemplate_duplicate_serviceescalation(temp_serviceescalation,temp_serviceescalation->host_name,this_servicelist->service_description);
- 
- 			/* exit on error */
- 			if(result==ERROR){
- 				xodtemplate_free_servicelist(temp_servicelist);
- 				return ERROR;
- 		                }
- 		        }
- 
- 		/* free memory we used for service list */
- 		xodtemplate_free_servicelist(temp_servicelist);
- 	        }
- 
- 
- 
- 	/****** DUPLICATE SERVICE ESCALATION DEFINITIONS WITH SERVICEGROUPS ******/
- 	/* THIS MUST BE DONE AFTER DUPLICATING FOR MULTIPLE HOST NAMES (SEE ABOVE) */
- 	for(temp_serviceescalation=xodtemplate_serviceescalation_list;temp_serviceescalation!=NULL;temp_serviceescalation=temp_serviceescalation->next){
- 
- 		/* skip serviceescalations without enough data */
- 		if(temp_serviceescalation->servicegroup_name==NULL)
- 			continue;
- 
- 		/* get list of services */
- 		temp_servicelist=xodtemplate_expand_servicegroups_and_services(temp_serviceescalation->servicegroup_name,NULL,NULL);
- 		if(temp_servicelist==NULL){
- #ifdef NSCORE
- 			snprintf(temp_buffer,sizeof(temp_buffer)-1,"Error: Could not expand servicegroups specified in service escalation (config file '%s', starting on line %d)\n",xodtemplate_config_file_name(temp_serviceescalation->_config_file),temp_serviceescalation->_start_line);
- 			temp_buffer[sizeof(temp_buffer)-1]='\x0';
- 			write_to_logs_and_console(temp_buffer,NSLOG_CONFIG_ERROR,TRUE);
- #endif
- 			return ERROR;
- 		        }
- 
- 		/* duplicate service escalation entries */
- 		first_item=TRUE;
- 		for(this_servicelist=temp_servicelist;this_servicelist!=NULL;this_servicelist=this_servicelist->next){
- 
- 			/* if this is the first duplication, use the existing entry if possible */
- 			if(first_item==TRUE && temp_serviceescalation->host_name==NULL && temp_serviceescalation->service_description==NULL){
- 
  				free(temp_serviceescalation->host_name);
  				temp_serviceescalation->host_name=strdup(this_servicelist->host_name);
  				free(temp_serviceescalation->service_description);
--- 3688,3693 ----
***************
*** 3828,3838 ****
  	        }
  
  
! 	/****** DUPLICATE SERVICE DEPENDENCY DEFINITIONS WITH MULTIPLE HOSTGROUP AND/OR HOST NAMES (MASTER AND DEPENDENT) ******/
  	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
  
  		/* skip service dependencies without enough data */
! 		if(temp_servicedependency->hostgroup_name==NULL && temp_servicedependency->dependent_hostgroup_name==NULL && temp_servicedependency->host_name==NULL && temp_servicedependency->dependent_host_name==NULL)
  			continue;
  
  		/* get list of master host names */
--- 3775,3785 ----
  	        }
  
  
! 	/****** DUPLICATE SERVICE DEPENDENCY DEFINITIONS WITH MULTIPLE MASTER HOSTGROUP AND/OR HOST NAMES ******/
  	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
  
  		/* skip service dependencies without enough data */
! 		if(temp_servicedependency->hostgroup_name==NULL && temp_servicedependency->host_name==NULL)
  			continue;
  
  		/* get list of master host names */
***************
*** 3846,3851 ****
--- 3793,3829 ----
  			return ERROR;
  		        }
  
+ 		/* duplicate the dependency definitions */
+ 		first_item=TRUE;
+ 		for(this_hostlist=master_hostlist;this_hostlist!=NULL;this_hostlist=this_hostlist->next){
+ 
+ 			/* existing definition gets first names */
+ 			if(first_item==TRUE){
+ 				free(temp_servicedependency->host_name);
+ 				temp_servicedependency->host_name=strdup(this_hostlist->host_name);
+ 				first_item=FALSE;
+ 				continue;
+ 			        }
+ 			else
+ 				result=xodtemplate_duplicate_servicedependency(temp_servicedependency,this_hostlist->host_name,temp_servicedependency->service_description,temp_servicedependency->dependent_host_name,temp_servicedependency->dependent_service_description);
+ 
+ 			/* exit on error */
+ 			if(result==ERROR)
+ 				return ERROR;
+ 		        }
+ 
+ 		/* free memory used to store host lists */
+ 		xodtemplate_free_hostlist(master_hostlist);
+ 	        }
+ 
+ 
+ 	/****** DUPLICATE SERVICE DEPENDENCY DEFINITIONS WITH MULTIPLE DEPENDENT HOSTGROUP AND/OR HOST NAMES ******/
+ 	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
+ 
+ 		/* skip service dependencies without enough data */
+ 		if(temp_servicedependency->dependent_hostgroup_name==NULL && temp_servicedependency->dependent_host_name==NULL)
+ 			continue;
+ 
  		/* get list of dependent host names */
  		dependent_hostlist=xodtemplate_expand_hostgroups_and_hosts(temp_servicedependency->dependent_hostgroup_name,temp_servicedependency->dependent_host_name);
  		if(dependent_hostlist==NULL){
***************
*** 3859,3888 ****
  
  		/* duplicate the dependency definitions */
  		first_item=TRUE;
- 		for(temp_hostlist=master_hostlist;temp_hostlist!=NULL;temp_hostlist=temp_hostlist->next){
- 
  			for(this_hostlist=dependent_hostlist;this_hostlist!=NULL;this_hostlist=this_hostlist->next){
  
  				/* existing definition gets first names */
  				if(first_item==TRUE){
- 					free(temp_servicedependency->host_name);
  					free(temp_servicedependency->dependent_host_name);
- 					temp_servicedependency->host_name=strdup(temp_hostlist->host_name);
  					temp_servicedependency->dependent_host_name=strdup(this_hostlist->host_name);
  					first_item=FALSE;
  					continue;
  				        }
  				else
! 					result=xodtemplate_duplicate_servicedependency(temp_servicedependency,temp_hostlist->host_name,temp_servicedependency->service_description,this_hostlist->host_name,temp_servicedependency->dependent_service_description);
  
  				/* exit on error */
  				if(result==ERROR)
  					return ERROR;
  			        }
- 		        }
  
  		/* free memory used to store host lists */
- 		xodtemplate_free_hostlist(master_hostlist);
  		xodtemplate_free_hostlist(dependent_hostlist);
  	        }
  
--- 3837,3860 ----
  
  		/* duplicate the dependency definitions */
  		first_item=TRUE;
  		for(this_hostlist=dependent_hostlist;this_hostlist!=NULL;this_hostlist=this_hostlist->next){
  
  			/* existing definition gets first names */
  			if(first_item==TRUE){
  				free(temp_servicedependency->dependent_host_name);
  				temp_servicedependency->dependent_host_name=strdup(this_hostlist->host_name);
  				first_item=FALSE;
  				continue;
  			        }
  			else
! 				result=xodtemplate_duplicate_servicedependency(temp_servicedependency,temp_servicedependency->host_name,temp_servicedependency->service_description,this_hostlist->host_name,temp_servicedependency->dependent_service_description);
  
  			/* exit on error */
  			if(result==ERROR)
  				return ERROR;
  		        }
  
  		/* free memory used to store host lists */
  		xodtemplate_free_hostlist(dependent_hostlist);
  	        }
  
***************
*** 3892,3898 ****
  	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
  
  		/* skip servicedependencies without enough data */
! 		if(temp_servicedependency->service_description==NULL || temp_servicedependency->host_name==NULL)
  			continue;
  
  		/* get list of services */
--- 3864,3870 ----
  	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
  
  		/* skip servicedependencies without enough data */
! 		if((temp_servicedependency->service_description==NULL || temp_servicedependency->host_name==NULL) && temp_servicedependency->servicegroup_name==NULL)
  			continue;
  
  		/* get list of services */
***************
*** 3913,3918 ****
--- 3885,3892 ----
  			/* if this is the first duplication, use the existing entry */
  			if(first_item==TRUE){
  
+ 				free(temp_servicedependency->host_name);
+ 				temp_servicedependency->host_name=strdup(this_servicelist->host_name);
  				free(temp_servicedependency->service_description);
  				temp_servicedependency->service_description=strdup(this_servicelist->service_description);
  				if(temp_servicedependency->service_description==NULL){
***************
*** 3925,3931 ****
  			        }
  
  			/* duplicate service escalation definition */
! 			result=xodtemplate_duplicate_servicedependency(temp_servicedependency,temp_servicedependency->host_name,this_servicelist->service_description,temp_servicedependency->dependent_host_name,temp_servicedependency->dependent_service_description);
  
  			/* exit on error */
  			if(result==ERROR){
--- 3899,3905 ----
  			        }
  
  			/* duplicate service escalation definition */
! 			result=xodtemplate_duplicate_servicedependency(temp_servicedependency,this_servicelist->host_name,this_servicelist->service_description,temp_servicedependency->dependent_host_name,temp_servicedependency->dependent_service_description);
  
  			/* exit on error */
  			if(result==ERROR){
***************
*** 3944,3950 ****
  	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
  
  		/* skip servicedependencies without enough data */
! 		if(temp_servicedependency->dependent_service_description==NULL || temp_servicedependency->dependent_host_name==NULL)
  			continue;
  
  		/* get list of services */
--- 3918,3924 ----
  	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
  
  		/* skip servicedependencies without enough data */
! 		if((temp_servicedependency->dependent_service_description==NULL || temp_servicedependency->dependent_host_name==NULL) && temp_servicedependency->dependent_servicegroup_name==NULL)
  			continue;
  
  		/* get list of services */
***************
*** 3965,3970 ****
--- 3939,3946 ----
  			/* if this is the first duplication, use the existing entry */
  			if(first_item==TRUE){
  
+ 				free(temp_servicedependency->dependent_host_name);
+ 				temp_servicedependency->dependent_host_name=strdup(this_servicelist->host_name);
  				free(temp_servicedependency->dependent_service_description);
  				temp_servicedependency->dependent_service_description=strdup(this_servicelist->service_description);
  				if(temp_servicedependency->dependent_service_description==NULL){
***************
*** 3977,3983 ****
  			        }
  
  			/* duplicate service escalation definition */
! 			result=xodtemplate_duplicate_servicedependency(temp_servicedependency,temp_servicedependency->host_name,temp_servicedependency->service_description,temp_servicedependency->dependent_host_name,this_servicelist->service_description);
  
  			/* exit on error */
  			if(result==ERROR){
--- 3953,3959 ----
  			        }
  
  			/* duplicate service escalation definition */
! 			result=xodtemplate_duplicate_servicedependency(temp_servicedependency,temp_servicedependency->host_name,temp_servicedependency->service_description,this_servicelist->host_name,this_servicelist->service_description);
  
  			/* exit on error */
  			if(result==ERROR){
